Index: uspace/lib/ext4/src/ialloc.c
===================================================================
--- uspace/lib/ext4/src/ialloc.c	(revision 59564e6d329e6a3146eea28acf2e3f71d2272a65)
+++ uspace/lib/ext4/src/ialloc.c	(revision cb15b49c1b1435f2f8f4b04d58fe1e1e8c4d65dd)
@@ -176,16 +176,10 @@
 errno_t ext4_ialloc_alloc_inode(ext4_filesystem_t *fs, uint32_t *index, bool is_dir)
 {
-	int pick_first_free = 0;
 	ext4_superblock_t *sb = fs->superblock;
-	uint32_t bgid;
-	uint32_t sb_free_inodes;
-	uint32_t avg_free_inodes;
-	uint32_t const bg_count = ext4_superblock_get_block_group_count(sb);
-
-retry:
-
-	bgid = 0;
-	sb_free_inodes = ext4_superblock_get_free_inodes_count(sb);
-	avg_free_inodes = sb_free_inodes / bg_count;
+
+	uint32_t bgid = 0;
+	uint32_t bg_count = ext4_superblock_get_block_group_count(sb);
+	uint32_t sb_free_inodes = ext4_superblock_get_free_inodes_count(sb);
+	uint32_t avg_free_inodes = sb_free_inodes / bg_count;
 
 	/* Try to find free i-node in all block groups */
@@ -216,6 +210,6 @@
 		 * blocks.
 		 */
-		if (((free_inodes >= avg_free_inodes) ||
-		    (bgid == bg_count - 1) || pick_first_free) && (free_blocks > 0)) {
+		if (((free_inodes >= avg_free_inodes) || (bgid == bg_count - 1)) &&
+		    (free_blocks > 0)) {
 			/* Load block with bitmap */
 			uint32_t bitmap_block_addr = ext4_block_group_get_inode_bitmap(
@@ -313,10 +307,4 @@
 	}
 
-	/* Try again with less strict conditions */
-	if (pick_first_free == 0) {
-		pick_first_free = 1;
-		goto retry;
-	}
-
 	return ENOSPC;
 }
Index: uspace/lib/ext4/src/superblock.c
===================================================================
--- uspace/lib/ext4/src/superblock.c	(revision 59564e6d329e6a3146eea28acf2e3f71d2272a65)
+++ uspace/lib/ext4/src/superblock.c	(revision cb15b49c1b1435f2f8f4b04d58fe1e1e8c4d65dd)
@@ -1315,12 +1315,10 @@
 	    ext4_superblock_get_blocks_per_group(sb);
 	uint64_t total_blocks =
-	    ext4_superblock_get_blocks_count(sb);
-	uint32_t first_block =
-	    ext4_superblock_get_first_data_block(sb);
+	    ext4_superblock_get_blocks_count(sb) - 1;
 
 	if (bgid < block_group_count - 1)
 		return blocks_per_group;
 	else
-		return (total_blocks - ((block_group_count - 1) * blocks_per_group)) - first_block;
+		return (total_blocks - ((block_group_count - 1) * blocks_per_group));
 }
 
@@ -1394,15 +1392,4 @@
 {
 	sb->reserved_gdt_blocks = host2uint32_t_le(n);
-}
-
-/** Get the size of the flex groups
- *
- * @param sb	Pointer to the superblock
- *
- * @return	Size of the flex groups
- */
-uint32_t ext4_superblock_get_flex_group_size(ext4_superblock_t *sb)
-{
-	return 2 << sb->log_groups_per_flex;
 }
 
@@ -1478,4 +1465,12 @@
 		 */
 
+		if (idx == 0 && block_size == 1024) {
+			/*
+			 * Special case for first group were the boot block
+			 * resides
+			 */
+			r++;
+		}
+
 		/* This accounts for the superblock */
 		r++;
@@ -1510,5 +1505,5 @@
 	uuid_t uuid;
 	uint32_t cur_ts;
-	uint64_t first_block = 0;
+	uint64_t first_block;
 	uint64_t fs_blocks;
 	uint32_t blocks_count;
@@ -1523,5 +1518,4 @@
 	uint32_t idx;
 	size_t fs_bsize;
-	size_t fs_bsize_log;
 	errno_t rc;
 	struct timespec ts;
@@ -1539,22 +1533,6 @@
 	cur_ts = ts.tv_sec;
 
-	fs_bsize = cfg->bsize;
-	switch (fs_bsize) {
-	case 1024:
-		first_block = 1;
-		fs_bsize_log = 0;
-		blocks_group = 8192;
-		break;
-	case 2048:
-		fs_bsize_log = 1;
-		blocks_group = 8192 * 2;
-		break;
-	case 4096:
-		fs_bsize_log = 2;
-		blocks_group = 8192 * 4;
-		break;
-	default:
-		return ENOTSUP;
-	}
+	fs_bsize = 1024;
+	first_block = 1; /* 1 for 1k block size, 0 otherwise */
 
 	if (fs_bsize % dev_bsize == 0) {
@@ -1565,4 +1543,7 @@
 		fs_blocks = dev_bcnt * (dev_bsize / fs_bsize);
 	}
+
+	/* FS blocks per group */
+	blocks_group = 8 * fs_bsize;
 
 	/* Inodes per group */
@@ -1600,7 +1581,8 @@
 	ext4_superblock_set_free_inodes_count(sb, inodes_count);
 	ext4_superblock_set_first_data_block(sb, first_block);
-	ext4_superblock_set_log_block_size(sb, fs_bsize_log);
+	/* Block size will be 1024 bytes */
+	ext4_superblock_set_log_block_size(sb, 0);
 	/* Fragment size should be equal to block size */
-	ext4_superblock_set_log_frag_size(sb, fs_bsize_log);
+	ext4_superblock_set_log_frag_size(sb, 0);
 	ext4_superblock_set_blocks_per_group(sb, blocks_group);
 	/* Should be the same as blocks per group. */
@@ -1652,4 +1634,5 @@
 	/* Compute free blocks */
 	free_blocks = blocks_count;
+	++free_blocks; // XXX Why?
 	for (idx = 0; idx < ngroups; idx++) {
 		free_blocks -= ext4_superblock_get_group_backup_blocks(sb, idx);
Index: uspace/lib/ieee80211/src/ieee80211.c
===================================================================
--- uspace/lib/ieee80211/src/ieee80211.c	(revision 59564e6d329e6a3146eea28acf2e3f71d2272a65)
+++ uspace/lib/ieee80211/src/ieee80211.c	(revision cb15b49c1b1435f2f8f4b04d58fe1e1e8c4d65dd)
@@ -803,5 +803,4 @@
 	if (rc != EOK) {
 		ddf_fun_unbind(fun);
-		ddf_fun_destroy(fun);
 		return rc;
 	}
@@ -810,5 +809,4 @@
 	if (rc != EOK) {
 		ddf_fun_unbind(fun);
-		ddf_fun_destroy(fun);
 		return rc;
 	}
Index: uspace/srv/audio/hound/hound.c
===================================================================
--- uspace/srv/audio/hound/hound.c	(revision 59564e6d329e6a3146eea28acf2e3f71d2272a65)
+++ uspace/srv/audio/hound/hound.c	(revision cb15b49c1b1435f2f8f4b04d58fe1e1e8c4d65dd)
@@ -146,5 +146,4 @@
 static void hound_remove_source_internal(hound_t *hound, audio_source_t *source)
 {
-	assert(fibril_mutex_is_locked(&hound->list_guard));
 	log_verbose("Removing source '%s'.", source->name);
 	if (!list_empty(&source->connections))
Index: uspace/srv/hid/compositor/compositor.c
===================================================================
--- uspace/srv/hid/compositor/compositor.c	(revision 59564e6d329e6a3146eea28acf2e3f71d2272a65)
+++ uspace/srv/hid/compositor/compositor.c	(revision cb15b49c1b1435f2f8f4b04d58fe1e1e8c4d65dd)
@@ -224,5 +224,4 @@
 
 	link_initialize(&win->link);
-	/* One initial reference will be for being in the window list */
 	refcount_init(&win->ref_cnt);
 	prodcons_initialize(&win->queue);
@@ -242,8 +241,5 @@
 static void window_destroy(window_t *win)
 {
-	if (win == NULL)
-		return;
-
-	if (!refcount_down(&win->ref_cnt))
+	if (!win || !refcount_down(&win->ref_cnt))
 		return;
 
@@ -895,7 +891,4 @@
 		    0, 0, width, height, win->transform, &x, &y, &width, &height);
 	}
-
-	/* Down refcount for removing from the window list */
-	window_destroy(win);
 
 	comp_damage(x, y, width, height);
Index: uspace/srv/locsrv/locsrv.c
===================================================================
--- uspace/srv/locsrv/locsrv.c	(revision 59564e6d329e6a3146eea28acf2e3f71d2272a65)
+++ uspace/srv/locsrv/locsrv.c	(revision cb15b49c1b1435f2f8f4b04d58fe1e1e8c4d65dd)
@@ -1387,7 +1387,4 @@
 	categ_dir_add_cat(&cdir, cat);
 
-	cat = category_new("printer-port");
-	categ_dir_add_cat(&cdir, cat);
-
 	return true;
 }
Index: version
===================================================================
--- version	(revision 59564e6d329e6a3146eea28acf2e3f71d2272a65)
+++ version	(revision cb15b49c1b1435f2f8f4b04d58fe1e1e8c4d65dd)
@@ -36,6 +36,6 @@
 
 VERSION = 0
-PATCHLEVEL = 8
-SUBLEVEL = 0
+PATCHLEVEL = 7
+SUBLEVEL = 2
 
 ifdef EXTRAVERSION
@@ -45,4 +45,4 @@
 endif
 
-NAME = Speranza
+NAME = Boosted Effort
 COPYRIGHT = Copyright (c) 2001-2018 HelenOS project
